function toggleDebuggingBox(event)
{
	if (event.altKey && event.metaKey)
	{
		var dataSource = dashcode.getDataSource("appStateData");
		var isDisplayed = dataSource.valueForKeyPath("content.showDebuggingBox");
		if (isDisplayed)
			dataSource.setValueForKeyPath(false, "content.showDebuggingBox");
		else
			dataSource.setValueForKeyPath(true, "content.showDebuggingBox");
	}
}

// Array used for testing purposes.
function volumeOptimizationTestArray()
{
    var newDetailArray = new Array();
	newDetailArray[0] =   { key: "Allocation Block Size", value: 512 };
    newDetailArray[1] =   { key: "Total Fragmented Blocks", value: 23 };
    newDetailArray[2] =   { key: "Used Size", value: "7567168 bytes" };
    newDetailArray[3] =   { key: "Largest Size", value: "17844229 bytes" };
    newDetailArray[4] =   { key: "Free Size", value: "30969515 bytes" };
    newDetailArray[5] =   { key: "Fragmentation", value: "24%" };
    newDetailArray[6] =   { key: "Additional Stuff", value: "More Info Here" };
	return newDetailArray;
}

// Array used for testing purposes.
function fileStructuresTestArray()
{
    var newDetailArray = new Array();
	newDetailArray[0] =   { key: "/Users/kevin/Developer/gnustep_svn/modules/dev-libs/steptalk/Languages/Smalltalk/SmalltalkInfo.plist", value: "Does not contain valid content" };
    newDetailArray[1] =   { key: "/Developer/Cocotron/1.0/Source/cocotron/Foundation/NSTimeZone/NSTimeZoneAbbreviations.plist", value: "Does not contain valid content" };
    newDetailArray[2] =   { key: "/Users/kevin/Developer/gnustep_svn/modules/dev-libs/gsweb/GSWeb/bundle-info.plist", value: "Does not contain valid content" };
    newDetailArray[3] =   { key: "/Developer/Cocotron/1.0/Source/cocotron/Foundation/NSTimeZone/NSTimeZoneRegions.plist", value: "Does not contain valid content" };
    newDetailArray[4] =   { key: "/Users/kevin/Developer/gnustep_svn/modules/dev-apps/projectcenter/Resources/Info-gnustep.plist", value: "Does not contain valid content" };
    newDetailArray[5] =   { key: "/Developer/Cocotron/1.0/Windows/i386/Frameworks/Foundation.framework/Versions/A/Resources/NSTimeZoneAbbreviations.plist", value: "Does not contain valid content" };
    newDetailArray[6] =   { key: "/Users/kevin/Developer/gnustep_svn/modules/usr-apps/systempreferences/Modules/Defaults/Resources/English.lproj/Defaults.plist", value: "Does not contain valid content" };
	return newDetailArray;
}


function addSampleDetailsKVO(event)
{
	var dataSource = dashcode.getDataSource("reportData");
	var content = dataSource.valueForKeyPath("content");
    var detailArray = dataSource.valueForKeyPath("content.detailArray");
	
    var newDetailArray = testArray();
    // dataSource.setValueForKeyPath(newDetailArray, "content.detailArray");
}

function addVolumeOptimizationDetails(event)
{
    var dataSource = dashcode.getDataSource("reportData");
    
    var newDetailArray = volumeOptimizationTestArray();
  
    var detailArray = dataSource.valueForKeyPath("content.detailArray");
	if(!detailArray)
	{
		detailArray = new Array();
	}
	MIReplaceContentsOfArrayWithObjects(detailArray, newDetailArray);

//    window.console.log(detailArray);
}



function removeLastObject(event)
{
	var dataSource = dashcode.getDataSource("reportData");
	var detailArray = dataSource.valueForKeyPath("content.detailArray");
	var lastObjectIndex = detailArray.length - 1;
	
	if (lastObjectIndex == 0)
	{
		detailArray[lastObjectIndex].key = null;
		detailArray[lastObjectIndex].value = null;
	}
	else
	{
		detailArray.removeObjectAtIndex(lastObjectIndex);
	}
}

function clearSampleDetails(event)
{
	var dataSource = dashcode.getDataSource("reportData");
//	var array = dataSource.valueForKeyPath("content.detailArray");
//	array.removeAllObjects();
	var array = new Array();
	array[0] = new Object();
	array[0].label = "";
	array[0].record = "";
	dataSource.setValueForKeyPath(null , "content.detailArray");

}



function toggleDetailsTable(event)
{
	var isVisible = MIValueForKeyPathInDataSource("content.showDetailList", "reportData");
	if (isVisible)
		MIReportHideDetailsTable();
	else
		MIReportShowDetailsTable();

}

function toggleSMARTImage(event)
{
	var isVisible = MIValueForKeyPathInDataSource("content.showSMARTImage", "reportData");
	if (isVisible)
		MIReportHideSMARTResults();
	else
		MIReportShowSMARTResults();

}



function addFileStructureDetails(event)
{
	var dataSource = dashcode.getDataSource("reportData");
    
    var newDetailArray = fileStructuresTestArray();
  
    var detailArray = dataSource.valueForKeyPath("content.detailArray");
	if(!detailArray)
	{
		detailArray = new Array();
	}
	MIReplaceContentsOfArrayWithObjects(detailArray, newDetailArray);
}


function addSampleDetailsKVO(event)
{
    // Insert Code Here
}


function MILogObject(object)
{
	for (key in object)
	{
		if ( (typeof object[key] != 'function') &&
			 (key != '__factories__') &&
			 (key != '__class_id__')
			)
		{
			window.console.log(
			"Key: " + key + "  " +
			"Object: " + object[key]
			);
		}
		
	}
	
}


function changeAppTitleTest(event)
{
	var dataSource = dashcode.getDataSource("appStateData");
	var currentTitle = dataSource.valueForKeyPath("content.processTitle");
	if (currentTitle == "TechTool Report")
	{
		MIReportSetApplicationTitle("TechTool Pro");
	}
	else
	{
		MIReportSetApplicationTitle("TechTool Deluxe");
	}
}
