// This can be split up into separate functions to handle the individual tools/tests.
function MIGenerateReport(
							timeStopped, 
							name,
							status,
							target,
							serialNumber,
							resultText,
							description,
							detailArray
											)
{
    // Retrieves data source. 
    var dataSource = dashcode.getDataSource("reportData");
	
	if (!dataSource) return;
	
	// Set the data source values 
    dataSource.setValueForKeyPath(timeStopped, "content.timeStopped");
    dataSource.setValueForKeyPath(name, "content.name");
    dataSource.setValueForKeyPath(status, "content.status");
    dataSource.setValueForKeyPath(target, "content.target");
    dataSource.setValueForKeyPath(serialNumber, "content.serialNumber");
    dataSource.setValueForKeyPath(resultText, "content.resultText");
    dataSource.setValueForKeyPath(description, "content.jobDescription");

	// Set the values for the detailArray
	if (detailArray)
	{
		MILogObject(detailArray);
		var observedDetailArray = dataSource.valueForKeyPath("content.detailArray");
		MIReplaceContentsOfArrayWithObjects(observedDetailArray, detailArray);
		dataSource.setValueForKeyPath(true, "content.showDetailList");
	}
	else
	{
		// Because we can't set a null value for the keyPath "content.detailArray"
		// without messing up the bindings of the table, we will hide the 
		// details table if we aren't passed a detail array.
		dataSource.setValueForKeyPath(false, "content.showDetailList");
	}

}

function MIReportUpdateData( 
								name, 
								status, 
								target, 
								serialNumber, 
								resultText, 
								timestamp, 
								description,
								targetType
												)
{
    // Retrieves data source. 
    var dataSource = dashcode.getDataSource("reportData");
	
	if (!dataSource) return;
	
	// Set the data source values 
    dataSource.setValueForKeyPath(timestamp, "content.timeStopped");
    dataSource.setValueForKeyPath(name, "content.name");
    dataSource.setValueForKeyPath(status, "content.status");
    dataSource.setValueForKeyPath(target, "content.target");
    dataSource.setValueForKeyPath(serialNumber, "content.serialNumber");
    dataSource.setValueForKeyPath(resultText, "content.resultText");
    dataSource.setValueForKeyPath(description, "content.jobDescription");

	MIReportSetTargetType(targetType);
//	window.console.log("Timestamp: " + timestamp);
	
}



function MIReportUpdateWithKeyValues(keys, values)
{
	for (key in keys)
	{
		if ( (typeof keys[key] != 'function') &&
			 (key != '__factories__') &&
			 (key != '__class_id__')
			)
		{
			window.console.log
			(
			"keys[key] = " + keys[key] + "\n" +
			"Changing key: " + keys[key] + " with new value: " + values[key]
			);
		}
		
	}
}

function MIReportProperties(report)
{
	var properties = new Array();
	for (key in report)
	{
		if ( (typeof report[key] != 'function') &&
			 (key != '__factories__') &&
			 (key != '__class_id__')
			)
		{
			properties.key = key;
			properties[key] = report[key];
		}
	}
	MILogObject(properties);
	return properties;
}